;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
;///////////////////////////////////////////////////////////////////
;Product:     CyberFanatic LT
;Version:     in-progress
;Last Update: December 2002
;Status:      Freeware
;Author:      Ramir, mailto:anb@tut.by,Gomel,Belarus
;///////////////////////////////////////////////////////////////////
;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\





;-----------------------------------------------------------
(defun DRAW-VIRT-BOXDF (ps pe mode color / 
ang9 p0 p1 p2 p3 p4 p5 p6 p7 p8 p14 pc1 pc2 pc3 flag-octant p95 p96)
;the box length depended of segment amount

(cond
((= mode 1) (setq h 8 ))
((= mode 2) (setq h 26))
((= mode 3) (setq h 34))
);cond

(if (/= name nil)
(progn
				(setq ang9 (angle ps pe))
				(cond
				((or(and (>= ang9 x330) (<= ang9 x360))(and (>= ang9 x0) (< ang9 x30)))
				(setq flag-octant 18)
				);1
				((and (>= ang9 x30) (< ang9 x90))
				(setq flag-octant 2)
				);1
				((and (>= ang9 x270) (< ang9 x330))
				(setq flag-octant 7)
				);1
				((and (>= ang9 x90) (< ang9 x150))
				(setq flag-octant 3)
				);1
				((and (>= ang9 x150) (< ang9 x210))
				(setq flag-octant 45)
				);1
				((and (>= ang9 x210) (< ang9 x270))
				(setq flag-octant 6)
				);1
				);cond

				(if (and (= keypressed 1) (/= keypressed-code 97));and A-symbol-code-97
				(progn
				(cond
				((= flag-octant 2)(setq flag-octant 3))
				((= flag-octant 3)(setq flag-octant 2))
				((= flag-octant 7)(setq flag-octant 6))
				((= flag-octant 6)(setq flag-octant 7))
				);cond
				);progn
				);if

    (setq p0 pe)

    (cond
    ((= flag-octant 18)(setq p14 p0))
    ((= flag-octant 7) (setq p14 (polar p0 x270 4)))
    ((= flag-octant 2) (setq p14 (polar p0 x90 4)))

    ((= flag-octant 3) (setq p14 (polar (polar p0 x180 h) x90 4)))
    ((= flag-octant 6) (setq p14 (polar (polar p0 x180 h) x270 4)))
    ((= flag-octant 45)(setq p14 (polar p0 x180 h)))
    );cond


(if (= mode 1)
(cond
    ((= ang9 x90)(setq p14 (polar (polar p0 x180 4) x90 4)));1
    ((= ang9 x270)(setq p14 (polar (polar p0 x180 4) x270 4)));1
);cond
);if


);progn
(setq p14 pt)
);if


(setq p1 (polar p14 x90 4))
(setq p2 (polar p1 x0    h)) 
(setq p3 (polar p2 x270  8)) 
(setq p4 (polar p14 x270 4))
(setq p5 (polar p1 x0 8))
(setq p6 (polar p4 x0 8))
(setq p7 (polar p2 x180 8))
(setq p8 (polar p3 x180 8))
(setq pc1 (polar p14 x0 4))
(setq pc2 (polar p14 x0 17))
(setq pc3 (polar p14 x0 30))


(grdraw p1 p2 color)
(grdraw p2 p3 color)
(grdraw p3 p4 color)
(grdraw p4 p1 color)
(if (/= mode 1)(grdraw p5 p6 color))
(if (= mode 3) (grdraw p7 p8 color))


(if (and (= flag-ent "LINE") (/= keypressed-A 0));and A-symbol-97-code
(progn
    (setq d1 (distance pt1 ps))
    (setq d2 (distance pt2 ps))
    (setq d3 (distance pt1 pt2))
    (if (> (+ d1 d2) (+ d3 1.0))
    (progn
        (setq d (min d1 d2))
        (cond 
        ((= d d1) (setq p pt1))
        ((= d d2) (setq p pt2))
        );cond
								(setq p95 p)
        (setq p96 (polar ps (angle p ps) 2.0))
        (grdraw p95 p96 color)
    );progn
    );if
);progn
);if

(list p0 p1 p2 p3 p4 p5 p6 p7 p8 p14 pc1 pc2 pc3 p95 p96)
);defun
;-------------------------------------------------------------

(defun DRAW-VIRT-ARROW (ps pe color / p1 p2 p3 ang9 )
(setq ang9 (angle ps pe))
(setq p3 (polar ps ang9 3.5))
(setq p1 (polar p3 (+ ang9 x90) 0.7))
(setq p2 (polar p3 (- ang9 x90) 0.7))

(grdraw ps p2 color)
(grdraw p2 p1 color)
(grdraw ps p1 color)
(grdraw p3 pe color)
(list ps pe)
);defun








(defun DRAW-VIRT-DF-ONLINE ( color / ang1 ang2 h2 pt9 dist9 dmin)
(setq h2 (distance pt1 pt))
(setq ang2 (angle pt1 pt))
(setq h3 (* (cos (- ang2 ang)) h2))
(setq p (polar pt1 ang h3))
(setq ang1 (angle p pt))
(setq dist9 (distance p pt))
(if (and (< dist9 (setq dmin (* (getvar "DIMASZ") 2)))(>= dist9 0.0)) 
(setq pt9 (polar p ang1 (+ dmin 0.1)))
(setq pt9 pt)
);if
(command "'_redrawall")
(if (/= mode 1)
(setq spis-arrow (DRAW-VIRT-ARROW p pt9 color))
(setq spis-arrow (DRAW-VIRT-BASE p pt9 color))
);if
(setq spis-boxdf (DRAW-VIRT-BOXDF p pt9 mode color))
);defun




(defun DRAW-VIRT-DF-ONARC ( color / p pt9 dist9 ang1 dmin)
(setq ang2 (angle CENTER pt))
(setq p (polar CENTER ang2 RADIUS))
(setq ang1 (angle p pt))
(setq dist9 (distance p pt))
(if (and (< dist9 (setq dmin (* (getvar "DIMASZ") 2)))(>= dist9 0.0)) 
(setq pt9 (polar p ang1 (+ dmin 0.1)))
(setq pt9 pt)
);if
(command "'_redrawall")
(if (/= mode 1)
(setq spis-arrow (DRAW-VIRT-ARROW p pt9 color))
(setq spis-arrow (DRAW-VIRT-BASE p pt9 color))
);if
(setq spis-boxdf  (DRAW-VIRT-BOXDF p pt9 mode color))
);defun




(defun DRAW-VIRT-DF-ALONE ( color / pt9 dist9 )
(command "'_redrawall")
;(setq spis-arrow (DRAW-VIRT-ARROW p pt color))
(setq spis-boxdf  (DRAW-VIRT-BOXDF p pt mode color))
);defun




(defun DRAWDF ( / ps-arrow pe-arrow 
p0-boxdf p1-boxdf p2-boxdf p3-boxdf p4-boxdf p5-boxdf p6-boxdf p7-boxdf  
p8-boxdf p14-boxdf pc1-boxdf pc2-boxdf pc3-boxdf p95 p96)

(setq start-name (entlast))
;(GETPARAM)

(if (/= spis-arrow nil)
(progn
(setq ps-arrow (nth 0 spis-arrow))
(setq pe-arrow (nth 1 spis-arrow))
);progn
);if

(setq p0-boxdf (nth 0 spis-boxdf))
(setq p1-boxdf (nth 1 spis-boxdf))
(setq p2-boxdf (nth 2 spis-boxdf))
(setq p3-boxdf (nth 3 spis-boxdf))
(setq p4-boxdf (nth 4 spis-boxdf))
(setq p5-boxdf (nth 5 spis-boxdf))
(setq p6-boxdf (nth 6 spis-boxdf))
(setq p7-boxdf (nth 7 spis-boxdf))
(setq p8-boxdf (nth 8 spis-boxdf))
(setq p14-boxdf (nth 9 spis-boxdf))
(setq pc1-boxdf (nth 10 spis-boxdf))
(setq pc2-boxdf (nth 11 spis-boxdf))
(setq pc3-boxdf (nth 12 spis-boxdf))
(setq p95 (nth 13 spis-boxdf))
(setq p96 (nth 14 spis-boxdf))


;arrow
(if (/= spis-arrow nil)
(progn


(if (not (FINDLAYER "DIM")) (command "LAYER" "M" "DIM" "C" 4 "DIM" ""))
(command "LEADER" ps-arrow pe-arrow "" "" "N")
 (command "INSERT" "base.dwg" pt 1 1 0)(entdel (entlast)) 

(if (= ver "14")
(if (/= mode 1)(setvar "DIMBLK" ".")(setvar "DIMBLK" "base"));if
(if (/= mode 1)(setvar "DIMLDRBLK" ".")(setvar "DIMLDRBLK" "base"));if
);if
(command "_DIM" "UPDATE" (entlast) "" "EXIT")
(if (= ver "14")
(setvar "DIMBLK" ".")
(setvar "DIMLDRBLK" ".")
);if
(command "chprop" (entlast) "" "LA" "DIM" "C" "BYLAYER" "")



(if (and (/= p95 nil)(/= p96 nil)(/= keypressed-A 0));and
(progn
(command "line" p95 p96 "")
(command "chprop" (entlast) "" "LA" "DIM" "C" "BYLAYER" "")
);progn
);if


);progn
);if/=nil spisarrow






;1 segment
(command "_pline" p1-boxdf p2-boxdf p3-boxdf p4-boxdf "_c")
(command "chprop" (entlast) "" "LA" "DIM" "C" "BYLAYER" "")
;2 segment

(if (/= mode 1)
(progn
(command "_pline" p5-boxdf p6-boxdf "")
(command "chprop" (entlast) "" "LA" "DIM" "C" "BYLAYER" "")
);progn
);if

;3 segment
(if (= mode 3)
(progn
(command "_pline" p7-boxdf p8-boxdf "")
(command "chprop" (entlast) "" "LA" "DIM" "C" "BYLAYER" "")
    (if (/= base-txt "")
    (progn
    (command "_text" "_J" "MC" pc3-boxdf 0 base-txt)
    (command "chprop" (entlast) "" "LA" "DIM" "C" "WHITE" "")
    );progn
    );if
);progn
);if

(if (= mode 1)
(progn
    (if (/= base-txt "")
    (progn
    (command "_text" "_J" "MC" pc1-boxdf 0 base-txt)
    (command "chprop" (entlast) "" "LA" "DIM" "C" "WHITE" "")
    );progn
    );if
);progn
);if




(if (and (/= df-znak-name nil)(/= mode 1))
(command "INSERT" df-znak-name p4-boxdf 1 1 0)
);if

(if (= flag-m 1)
(progn
(if (= mode 2) (setq p-m p2-boxdf)(setq p-m p7-boxdf))
(command "INSERT" "circ-m1.dwg" p-m 1 1 0)
(setq pc2-boxdf (list (- (car pc2-boxdf) 2.5) (cadr pc2-boxdf)))
);progn
);if

(if (and (/= df-txt "")(/= mode 1))
(progn
(command "_text" "_J" "MC" pc2-boxdf 0 df-txt)
(command "chprop" (entlast) "" "LA" "DIM" "C" "WHITE" "")
);progn
);if


(setq NBR (DEFINE-NBR start-name))
(MAKEGROUP NBR)
;(SETPARAM)

);defun






;dynamic base
(defun DF-DYNAMIC ( mode   df-znak-name   flag-m   df-txt  base-txt / 
name data k pt1 pt2 ang flag-ent CENTER RADIUS z flag pt ps pe s txt keypressed
spis-arrow spis-boxdf keypressed-code keypressed-A)

(setq color 1)
(setq k 0)
(setq keypressed 0)
(setq keypressed-A 1)
(setq keypressed-code 1)

(setq name nil data nil pt1 nil pt2 nil CENTER nil RADIUS nil ang nil spis-arrow nil
spis-boxdf nil ps nil pe nil)


(if (/= (setq name (car (setq spis (nentsel)))) nil)
(progn
      (setq data (entget name))
      (cond
      ((= (cdr (assoc 0 data)) "LINE")
      (progn
        (setq pt1 (cdr (assoc 10 data)))
        (setq pt2 (cdr (assoc 11 data)))
        (setq ang (angle pt1 pt2))
        (setq flag-ent "LINE")
      );progn
      );1
      ((= (cdr (assoc 0 data)) "LEADER")
      (progn
        (setq pt1 (cdr (assoc 10 data)))
        (setq data (reverse data))
        (setq pt2 (cdr (assoc 10 data)))
        (setq ang (angle pt1 pt2))
        (setq ang1 (+ ang x90))
        (setq flag-ent "LINE")
      );progn
      );1
      ((or (= (cdr (assoc 0 data)) "ARC")(= (cdr (assoc 0 data)) "CIRCLE"));or
      (progn
        (setq CENTER (cdr (assoc 10 data)))
        (setq RADIUS (cdr (assoc 40 data)))
        (setq flag-ent "ARC")
      );progn
      );2
      );cond


(if (/= (setq nameblock (car (nth 3 spis))) nil) 
(progn
(setq datablock (entget nameblock))
    (if (= (cdr (assoc 0 datablock)) "INSERT")
    (progn
        (setq ip-block (cdr (assoc 10 datablock)))
        (cond
        ((= flag-ent "LINE")
        (progn
        (setq pt1 (list (+ (car pt1) (car ip-block))(+ (cadr pt1) (cadr ip-block))))
        (setq pt2 (list (+ (car pt2) (car ip-block))(+ (cadr pt2) (cadr ip-block))))
        (setq ang (angle pt1 pt2))
        );progn
        );1
        ((= flag-ent "ARC")
        (setq CENTER (list (+ (car CENTER) (car ip-block))(+ (cadr CENTER) (cadr ip-block))))
        );1
        );cond
    );progn
    );if
);progn
);if

);progn
);if/=setq name nentsel


(while (/= k 1)

(setq z  (grread 1 5 2))
(setq flag (car z))
(setq pt (cadr z))
(setq pe pt)
(princ z)
(cond
;===========
;===========
;===========
;---------------------------Mouse go on graphic field-------------------------
((= flag 5)
(progn

(cond
((= flag-ent "LINE")(DRAW-VIRT-DF-ONLINE color))
((= flag-ent "ARC")(DRAW-VIRT-DF-ONARC color))
(T (DRAW-VIRT-DF-ALONE color))
);cond

);progn
);e=5
;---------------------------Pressed keyboard--------------------------------
((= flag 2)
(progn
(if (= keypressed 0)(setq keypressed 1)(setq keypressed 0));if
(setq keypressed-code (cadr z))

(cond
((and (= keypressed-A 0) (= keypressed-code 97))(setq keypressed-A 1))
((and (= keypressed-A 1) (= keypressed-code 97))(setq keypressed-A 0))
);cond

);progn
);E=2

;---------------------------Click on graphic field--------------------------
((= flag 3)
(progn
(setq k 1)
);progn
);E=3
;---------------------------Mouse click on button---------------------------
((= flag 11)
(progn
(setq s (cadr z))
(cond 
((= s nz1) 
(progn
(setq p1 (getpoint "First corner:"))
(setq p2 (getcorner p1 "Second corner:"))
(command "ZOOM" "W" p1 p2)
);progn
);2110
((= s nz2) (command "ZOOM" "P"))
((= s nz3) (command "ZOOM" "E"))
((= s nz4) (command "_.PAN" pause pause))
((= s nz5) (command "ZOOM" ""))
((= s 0) (setq k 1));---------------------------Mouse right-klick on graphic field---------------
);cond
(print s)
);progn
);E=11
;===========
;===========
;===========
);cond

);while
(command "'_redrawall")
;draw if not rigth-mouse click
(if (/= s 0) (DRAWDF));if
(setq a T)
);DEFUN







(defun ACTION-D ()
(mode_tile d-n 4)(setq d-n $key)(mode_tile d-n 4)
;(cond
;((= d-n "d6")
;(progn
;(mode_tile dfmode-N 4)(setq dfmode-N "dfmode7")(mode_tile dfmode-N 4)
;(mode_tile snap-n 4)(setq snap-n "snap1")(mode_tile snap-n 4)
;(mode_tile symb 4)(setq symb "c-m-key")(mode_tile symb 4)
;(mode_tile symb1 4)(setq symb1 "diam-key")(mode_tile symb1 4)
;);progn
;);1
;((= d-n "d5")
;(progn
;(setq str1 (strcat "%%c" str1))
;(set_tile "e1" str1)
;);progn
;);1
;((= d-n "d9")
;(progn
;(setq str1 (strcat "T" str1))
;(set_tile "e1" str1)
;);progn
;);1
;);cond

(cond
((= d-n "d1")  (INIT-IMG "img-df1"  "cylindri" -16))
((= d-n "d2")  (INIT-IMG "img-df1"  "bienie"   -16))
((= d-n "d3")  (INIT-IMG "img-df1"  "kruglost" -16))
((= d-n "d4")  (INIT-IMG "img-df1"  "parallel" -16))
((= d-n "d5")  (INIT-IMG "img-df1"  "perpendi" -16))
((= d-n "d6")  (INIT-IMG "img-df1"  "pozicion" -16))
((= d-n "d7")  (INIT-IMG "img-df1"  "ploskost" -16))
((= d-n "d8")  (INIT-IMG "img-df1"  "simmetri" -16))
((= d-n "d9")  (INIT-IMG "img-df1"  "soosn"    -16))
((= d-n "d10") (INIT-IMG "img-df1"  "ugol"     -16))
((= d-n "d11") (INIT-IMG "img-df1"  "blank"   -15))
((= d-n "d12") (INIT-IMG "img-df1"  "blank"   -15))
);cond

);defun



(defun INIT-IMG ( key slide-name color / x y )
(start_image key)
(setq x (dimx_tile key))
(setq y (dimy_tile key))
(fill_image 0 0 x y color)
(slide_image 0 0 (- x 1) (- y 1) slide-name)
(end_image)
);defun



(defun ACTION-M-KEY ()
;----------------------
(if (/= flag-m 1) 
(progn
(setq symb "c-m-key")
(setq flag-m 1)
(INIT-IMG "m-key" "circ-m1" -2)
);progn
(progn
(setq flag-m 0)
(INIT-IMG "m-key" "blank" -15)
);progn
);if
);defun






(defun ACTION-DIAM-KEY ()
;----------------------
(if (/= flag-diam 1) 
(progn
(setq flag-diam 1)
(INIT-IMG "diam-key" "diam" -2)
);progn
(progn
(setq flag-diam 0)
(INIT-IMG "diam-key" "blank" -15)
);progn
);if
);defun




(defun PL1-LIST-DF ()
(setq slist1 (list "0.002" "0.003" "0.004" "0.005" "0.008" "0.01" "0.02" "0.03" 
"0.04" "0.05" "0.08" "0.1" "0.2" "0.3" "0.5" "1"))                   
(if (>= (getvar "maxsort") (length slist1))
(princ)
(setq slist1 (reverse slist1))
);if
(start_list "pl1")
(mapcar 'add_list slist1)
(end_list)
);defun


(defun PL2-LIST-DF ()
(setq slist2 (list "" "" "" "" "" "" "" "" "" "" "" ""
"" "" "" "" "" "" "" "" "" "" ""
"" "1" "1" "1" "1" "1" "1" "1" "1" "1" "1"
"1" "1" "1" "1" "1" "1" "1" "1" "1" "1" "1" "1" "1"))
(if (>= (getvar "maxsort") (length slist2))
(princ)
(setq slist2 (reverse slist1))
);if
(start_list "pl2")
(mapcar 'add_list slist2)
(end_list)
);defun




		(defun ACTION-PL1-DF ( / index)
(setq index (atoi $Value))
(setq str1 (nth index slist1))
(set_tile "e1" str1)
);defun


		(defun ACTION-PL2-DF ( / index)
(setq index (atoi $Value))
(setq str2 (nth index slist2))
(set_tile "e2" str2)
);defun












(defun ACTION-E1 (/ index)
(setq str1 $Value)
);defun


(defun ACTION-E2 (/ index)
(setq str2 $Value)
);defun








;--------------------------------------------------------------
;//////////////////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////
;//////////////////////////////////////////////////////////////
(defun C:DF-WIZARD ( / str1 str2 df-txt) ;MAIN Function
(GETPARAM)
(setq flag-diam 0)
(setq flag-m 0)
(setq str1 "")
(setq str2 "")

 (setq f (load_dialog "dfwizard.dcl"))
 (if (not (new_dialog "dfwizard" f)) (exit))

(INIT-IMG "d1" "cylindri" -2)
;----------------------
(INIT-IMG "d2" "bienie"   -2)
;----------------------
(INIT-IMG "d3" "kruglost" -2)
;----------------------
(INIT-IMG "d4" "parallel" -2)
;----------------------
(INIT-IMG "d5" "perpendi" -2)
;----------------------
(INIT-IMG "d6" "pozicion" -2)
;----------------------
(INIT-IMG "d7" "ploskost" -2)
;----------------------
(INIT-IMG "d8" "simmetri" -2)
;----------------------
(INIT-IMG "d9" "soosn"    -2)
;----------------------
(INIT-IMG "d10" "ugol"    -2)
;----------------------
(INIT-IMG "d11" "blank"   -2)
;----------------------
(INIT-IMG "d12" "blank"   -2)
;----------------------
;----------------------
;----------------------
;----------------------
(INIT-IMG "img-df1" "blank" -15)
(INIT-IMG "m-key" "blank" -15)
(INIT-IMG "diam-key" "blank" -15)
;----------------------
;----------------------
;----------------------
;----------------------





(PL1-LIST-DF)
(PL2-LIST-DF)

(mode_tile "d11" 4)
(setq d-n "d11")

(action_tile "d1" "(ACTION-D)")
(action_tile "d2" "(ACTION-D)")
(action_tile "d3" "(ACTION-D)")
(action_tile "d4" "(ACTION-D)")
(action_tile "d5" "(ACTION-D)")
(action_tile "d6" "(ACTION-D)")
(action_tile "d7" "(ACTION-D)")
(action_tile "d8" "(ACTION-D)")
(action_tile "d9" "(ACTION-D)")
(action_tile "d10" "(ACTION-D)")
(action_tile "d11" "(ACTION-D)")
(action_tile "d12" "(ACTION-D)")

(action_tile "pl1" "(ACTION-PL1-DF)")
(action_tile "pl2" "(ACTION-PL2-DF)")

(action_tile "e1" "(ACTION-E1)")
(action_tile "e2" "(ACTION-E2)")


(action_tile "m-key" "(ACTION-M-KEY)")
(action_tile "diam-key" "(ACTION-DIAM-KEY)")


(setq x (start_dialog)); x=1 -accept, x=0 -cancel
(unload_dialog 1)


(if (= x 1)
(progn


(cond
((= d-n "d1")  (setq df-znak-name "1cul.dwg" ))
((= d-n "d2")  (setq df-znak-name "2bie.dwg" ))
((= d-n "d3")  (setq df-znak-name "3kru.dwg" ))
((= d-n "d4")  (setq df-znak-name "4par.dwg" ))
((= d-n "d5")  (setq df-znak-name "5per.dwg" ))
((= d-n "d6")  (setq df-znak-name "6pos.dwg" ))
((= d-n "d7")  (setq df-znak-name "7plo.dwg" ))
((= d-n "d8")  (setq df-znak-name "8sim.dwg" ))
((= d-n "d9")  (setq df-znak-name "9soo.dwg" ))
((= d-n "d10") (setq df-znak-name "10ugo.dwg"))
((= d-n "d11") (setq df-znak-name nil))
((= d-n "d12") (setq df-znak-name nil))
(T (setq df-znak-name nil))

);cond




(setq base-txt str2)
(setq df-txt str1)
(if (= base-txt "") (setq mode 2) (setq mode 3));if
(if (= flag-diam 1) (setq df-txt (strcat "%%c" df-txt)));if
(if (= df-znak-name nil) (setq mode 1));if
(DF-DYNAMIC   mode   df-znak-name   flag-m    df-txt   base-txt)

);progn
);if =1


(SETPARAM)
(princ)
);defun

















