;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
;///////////////////////////////////////////////////////////////////
;Product:     CyberFanatic LT
;Version:     in-progress
;Last Update: December 2002
;Status:      Freeware
;Author:      Ramir, mailto:anb@tut.by,Gomel,Belarus
;///////////////////////////////////////////////////////////////////
;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\





;-----------------------------------------------------------
(defun DRAW-VIRT-BOX (ps pe color / ang9 p0 p1 p2 p3 p4 p12 p23 p43 p14 p95 p96)
(setq txth 3.5)
(setq ang9 (angle ps pe))
(setq p0 (polar pe ang9 (+ TxtH 0.5)))
(setq p1 (polar (polar p0  (+ x180 ang9) 4) (+ x90 ang9) 4))
(setq p2 (polar p1 (+ x0 ang9) 8)) 
(setq p3 (polar p2 (+ x270 ang9) 8)) 
(setq p4 (polar p3 (+ x180 ang9) 8))
(setq p12 (polar p1 (+ x0 ang9) 4)) 
(setq p23 (polar p2 (+ x270 ang9) 4)) 
(setq p43 (polar p4 (+ x0 ang9) 4)) 
(setq p14 (polar p4 (+ x90 ang9) 4)) 
(grdraw p1 p2 color)
(grdraw p2 p3 color)
(grdraw p3 p4 color)
(grdraw p4 p1 color)

(if (and (= flag-ent "LINE") (= keypressed 0));and
(progn
    (setq d1 (distance pt1 ps))
    (setq d2 (distance pt2 ps))
    (setq d3 (distance pt1 pt2))
    (if (> (+ d1 d2) (+ d3 1.0))
    (progn
        (setq d (min d1 d2))
        (cond 
        ((= d d1) (setq p pt1))
        ((= d d2) (setq p pt2))
        );cond
								(setq p95 p)
        (setq p96 (polar ps (angle p ps) (+ 2.0 (/ (getvar "DIMASZ") 2) )))
        (grdraw p95 p96 color)
    );progn
    );if
);progn
);if


(list p1 p2 p3 p4 pe p0 ang9 p95 p96)
);defun
;-------------------------------------------------------------

(defun DRAW-VIRT-BASE (ps pe color / p1 p2 p3 ang9 )
(setq ang9 (angle ps pe))
(setq p1 (polar ps (+ ang9 x90) 2.0))
(setq p2 (polar ps (- ang9 x90) 2.0))
(setq p3 (polar ps ang9 3.5))
(grdraw p1 p2 color)
(grdraw p2 p3 color)
(grdraw p3 p1 color)
(grdraw p3 pe color)
(list ps pe)
);defun








(defun DRAW-VIRT-BASE-ONLINE ( color / ang1 ang2 h2 pt9 dist9 dmin)
(setq h2 (distance pt1 pt))
(setq ang2 (angle pt1 pt))
(setq h3 (* (cos (- ang2 ang)) h2))
(setq p (polar pt1 ang h3))
(setq ang1 (angle p pt))
(setq dist9 (distance p pt))
(if (and (< dist9 (setq dmin (* (getvar "DIMASZ") 2)))(>= dist9 0.0)) ;8.0
(setq pt9 (polar p ang1 (+ dmin 0.1)))
(setq pt9 pt)
);if
(command "'_redrawall")
(setq spis-base (DRAW-VIRT-BASE p pt9 color))
(setq spis-box (DRAW-VIRT-BOX p pt9 color))
);defun




(defun DRAW-VIRT-BASE-ONARC ( color / pt9 dist9 dmin)
(setq ang2 (angle CENTER pt))
(setq p (polar CENTER ang2 RADIUS))
(setq ang1 (angle p pt))
(setq dist9 (distance p pt))
(if (and (< dist9 (setq dmin (* (getvar "DIMASZ") 2)))(>= dist9 0.0)) 
(setq pt9 (polar p ang1 (+ dmin 0.1)))
(setq pt9 pt)
);if
(command "'_redrawall")
(setq spis-base (DRAW-VIRT-BASE p pt9 color))
(setq spis-box  (DRAW-VIRT-BOX p pt9 color))
);defun



(defun DRAWBASE ( )
(setq start-name (entlast))

(setq ps-base (nth 0 spis-base))
(setq pe-base (nth 1 spis-base))

(setq p1-box (nth 0 spis-box))
(setq p2-box (nth 1 spis-box))
(setq p3-box (nth 2 spis-box))
(setq p4-box (nth 3 spis-box))
(setq p43-box (nth 4 spis-box))
(setq p0-box (nth 5 spis-box))
(setq ang-t  (nth 6 spis-box))
(setq p95 (nth 7 spis-box ))
(setq p96 (nth 8 spis-box ))



(if (not (FINDLAYER "DIM")) (command "LAYER" "M" "DIM" "C" 4 "DIM" ""))
;(command "_solid" p1-base p2-base p3-base p3-base "")
(command "INSERT" "base.dwg" pt 1 1 0)(entdel (entlast))
(command "LEADER" ps-base pe-base "" "" "N")
(if (= ver "14")
(setvar "DIMBLK" "base")
(setvar "DIMLDRBLK" "base")
);if
(command "_DIM" "UPDATE" (entlast) "" "EXIT")
(if (= ver "14")
(setvar "DIMBLK" ".")
(setvar "DIMLDRBLK" ".")
);if
(command "chprop" (entlast) "" "LA" "DIM" "C" "BYLAYER" "")


(command "chprop" (entlast) "" "LA" "DIM" "C" "BYLAYER" "")
(command "_pline" p1-box p2-box p3-box p4-box "_c")
(command "chprop" (entlast) "" "LA" "DIM" "C" "BYLAYER" "")
(command "LINE" ps-base p43-box "")
(command "chprop" (entlast) "" "LA" "DIM" "C" "BYLAYER" "")
;(setq ang-t (angle p1-box p2-box))
(setq ang-t1 (abs (+ ang-t x90)))

(cond
((or (= ang-t1 x0) (= ang-t1 x90) (= ang-t1 x180) (= ang-t1 x270) (= ang-t1 x360)  )
(progn
(command "_text" "_J" "MC" p0-box x0 txt)
(command "chprop" (entlast) "" "LA" "DIM" "C" "WHITE" "")
(setq fl 1)
);progn
);1
((and (> ang-t x0) (< ang-t x180))
(progn
(command "_text" "_J" "MC" p0-box (+ (MYDAR ang-t1) 180) txt)
(command "chprop" (entlast) "" "LA" "DIM" "C" "WHITE" "")
(setq fl 2)
);progn
);2
((and (> ang-t x180) (< ang-t x360))
(progn
(command "_text" "_J" "MC" p0-box (MYDAR ang-t1) txt)
(command "chprop" (entlast) "" "LA" "DIM" "C" "WHITE" "")
(setq fl 3)
);progn
);3

);cond


(if (and (/= p95 nil)(/= p96 nil)(= keypressed 0));and
(progn
(command "line" p95 p96 "")
(command "chprop" (entlast) "" "LA" "DIM" "C" "BYLAYER" "")
);progn
);if



(setq NBR (DEFINE-NBR start-name))
(MAKEGROUP NBR)

);defun






;dynamic base
(defun C:MYBASE ( /  k pt1 pt2 ang flag-ent CENTER RADIUS z flag pt pe s txt keypressed)
(GETPARAM)

;-----------------
(setq txt (SX 3))
;-----------------

(setq color 1)
(setq k 0)
(setq keypressed 0)

(if (/= (setq name (car (setq spis (nentsel)))) nil)
(progn
(setq data (entget name))


(cond
((= (cdr (assoc 0 data)) "LINE")
(progn
  (setq pt1 (cdr (assoc 10 data)))
  (setq pt2 (cdr (assoc 11 data)))
  (setq ang (angle pt1 pt2))
  ;(setq ang1 (+ ang x90))
  (setq flag-ent "LINE")
);progn
);1
((= (cdr (assoc 0 data)) "LEADER")
(progn
  (setq pt1 (cdr (assoc 10 data)))
  (setq data (reverse data))
  (setq pt2 (cdr (assoc 10 data)))
  (setq ang (angle pt1 pt2))
  (setq ang1 (+ ang x90))
  (setq flag-ent "LINE")
);progn
);1
((or (= (cdr (assoc 0 data)) "ARC")(= (cdr (assoc 0 data)) "CIRCLE"));or
(progn
  (setq CENTER (cdr (assoc 10 data)))
  (setq RADIUS (cdr (assoc 40 data)))
  (setq flag-ent "ARC")
);progn
);2
);cond

(if (/= (setq nameblock (car (nth 3 spis))) nil) 
(progn
(setq datablock (entget nameblock))
    (if (= (cdr (assoc 0 datablock)) "INSERT")
    (progn
        (setq ip-block (cdr (assoc 10 datablock)))
        (cond
        ((= flag-ent "LINE")
        (progn
        (setq pt1 (list (+ (car pt1) (car ip-block))(+ (cadr pt1) (cadr ip-block))))
        (setq pt2 (list (+ (car pt2) (car ip-block))(+ (cadr pt2) (cadr ip-block))))
        (setq ang (angle pt1 pt2))
        );progn
        );1
        ((= flag-ent "ARC")
        (setq CENTER (list (+ (car CENTER) (car ip-block))(+ (cadr CENTER) (cadr ip-block))))
        );1
        );cond
    );progn
    );if
);progn
);if




(while (/= k 1)

(setq e  (grread 1 5 2))

(setq z e)
(setq flag (car z))
(setq pt (cadr z))
(setq pe pt)
(cond
;===========
;===========
;===========
;---------------------------Mouse go on graphic field-------------------------
((= flag 5)
(progn

(cond
((= flag-ent "LINE")(DRAW-VIRT-BASE-ONLINE 1))
((= flag-ent "ARC")(DRAW-VIRT-BASE-ONARC 1))
);cond

);progn
);e=5
;---------------------------Pressed keyboard--------------------------------
((= flag 2)
(progn
(if (= keypressed 0)(setq keypressed 1)(setq keypressed 0));if
);progn
);E=2

;---------------------------Click on graphic field--------------------------
((= flag 3)
(progn
(setq k 1)

);progn
);E=3
;---------------------------Mouse click on button---------------------------
((= flag 11)
(progn
(setq s (cadr z))
(cond 
((= s nz1) 
(progn
(setq p1 (getpoint "First corner:"))
(setq p2 (getcorner p1 "Second corner:"))
(command "ZOOM" "W" p1 p2)
);progn
);2110
((= s nz2) (command "ZOOM" "P"))
((= s nz3) (command "ZOOM" "E"))
((= s nz4) (command "_.PAN" pause pause))
((= s nz5) (command "ZOOM" ""))
((= s 0) (setq k 1));---------------------------Mouse right-klick on graphic field---------------
);cond
(print s)
);progn
);E=11
;===========
;===========
;===========
);cond

);while
(command "'_redrawall")
(DRAWBASE)
(setq a T)
);progn
(setq a nil)
);if/=nilsetq name

(SETPARAM)
);DEFUN


