;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
;///////////////////////////////////////////////////////////////////
;Product:     CyberFanatic LT
;Version:     in-progress
;Last Update: December 2002
;Status:      Freeware
;Author:      Ramir, mailto:anb@tut.by,Gomel,Belarus
;///////////////////////////////////////////////////////////////////
;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\



(defun DRAW-VIRT-SHER (ps pe color / p p1 p2 p00 p01 p02 p03 p04 d1 d2 d3 d p95 p96)
(setq ang1 (angle ps pe))


(cond
((or (> ang1 3.149) (= ang1 0))
(progn
(setq p1 (polar ps (- ang1 0.55) 6))
(setq p2 (polar ps (+ ang1 0.55) 3))
);progn
);1
((and (<= ang1 3.149) (/= ang1 0))
(progn
(setq p1 (polar ps (+ ang1 0.55) 3))
(setq p2 (polar ps (- ang1 0.55) 6))
);progn
);2
);cond
(setq p00 (polar ps ang1 3.0))
(setq p01 (polar p00 (+ ang1 x90) 4.0))
(setq p02 (polar p01 ang1 3.5))
(setq p03 (polar p02 (- ang1 x90) 5.0))
(setq p04 (polar p03 (- ang1 x180) 3.5))
(command "'_redrawall")
(grdraw p1 ps color)
(grdraw ps p2 color)
(grdraw p01 p02 color)
(grdraw p02 p03 color)
(grdraw p03 p04 color)
(grdraw p04 p01 color)


(if (and (= flag-ent "LINE") (= keypressed 0));and
(progn
    (setq d1 (distance pt1 ps))
    (setq d2 (distance pt2 ps))
    (setq d3 (distance pt1 pt2))
    (if (> (+ d1 d2) (+ d3 1.0))
    (progn
        (setq d (min d1 d2))
        (cond 
        ((= d d1) (setq p pt1))
        ((= d d2) (setq p pt2))
        );cond
								(setq p95 p)
        (setq p96 (polar ps (angle p ps) 2.0))
        (grdraw p95 p96 color)
    );progn
    );if
);progn
);if

(list ps ang1 p95 p96)
);defun







(defun DRAW-VIRT-SHER-ONLINE ( color / h2 ang2 h3 )
(setq h2 (distance pt1 pt))
(setq ang2 (angle pt1 pt))
(setq h3 (* (cos (- ang2 ang)) h2))
(setq p (polar pt1 ang h3))
(setq spis-sher (DRAW-VIRT-SHER p pt color))
);defun




(defun DRAW-VIRT-SHER-ONARC ( color / ang2 )
(setq ang2 (angle CENTER pt))
(setq p (polar CENTER ang2 RADIUS))
(setq spis-sher (DRAW-VIRT-SHER p pt color))
);defun





(defun DRAW-SHER (p ang1 txt / p95 p96)
;(list ps ang1 p95 p96)
(setq p95 (nth 2 spis-sher ))
(setq p96 (nth 3 spis-sher ))
(if (and (/= p95 nil)(/= p96 nil)(= keypressed 0));and
(progn
(if (not (FINDLAYER "DIM")) (command "LAYER" "M" "DIM" "C" 4 "DIM" ""));if
(command "line" p95 p96 "")
(command "chprop" (entlast) "" "LA" "DIM" "C" "BYLAYER" "")
);progn
);if
(-SHER p ang1 txt)
);defun











;dynamic sher
(defun SHER-DYNAMIC ( / name data k pt1 pt2 ang1 ang flag-ent 
																								CENTER RADIUS p pt z s spis-sher)
(setq color 1)
(setq k 0)
(setq keypressed 0)

(if (/= (setq name (car (setq spis (nentsel)))) nil)
(progn
(setq data (entget name))


(cond
((= (cdr (assoc 0 data)) "LINE")
(progn
  (setq pt1 (cdr (assoc 10 data)))
  (setq pt2 (cdr (assoc 11 data)))
  (setq ang (angle pt1 pt2))
  (setq ang1 (+ ang x90))
  (setq flag-ent "LINE")
);progn
);1
((= (cdr (assoc 0 data)) "LEADER")
(progn
  (setq pt1 (cdr (assoc 10 data)))
  (setq data (reverse data))
  (setq pt2 (cdr (assoc 10 data)))
  (setq ang (angle pt1 pt2))
  (setq ang1 (+ ang x90))
  (setq flag-ent "LINE")
);progn
);1
((or (= (cdr (assoc 0 data)) "ARC")(= (cdr (assoc 0 data)) "CIRCLE"));or
(progn
  (setq CENTER (cdr (assoc 10 data)))
  (setq RADIUS (cdr (assoc 40 data)))
  ;(setq START-ANGLE (cdr (assoc 50 data)))
  ;(setq END-ANGLE (cdr (assoc 51 data)))
  (setq flag-ent "ARC")
);progn
);2
);cond


;if "INSERT" then recalculate coordinates from INSERT-CS to WORLD-CS
(if (/= (setq nameblock (car (nth 3 spis))) nil) 
(progn
(setq datablock (entget nameblock))
    (if (= (cdr (assoc 0 datablock)) "INSERT")
    (progn
        (setq ip-block (cdr (assoc 10 datablock)))
        (cond
        ((= flag-ent "LINE")
        (progn
        (setq pt1 (list (+ (car pt1) (car ip-block))(+ (cadr pt1) (cadr ip-block))))
        (setq pt2 (list (+ (car pt2) (car ip-block))(+ (cadr pt2) (cadr ip-block))))
        (setq ang (angle pt1 pt2))
        );progn
        );1
        ((= flag-ent "ARC")
        (setq CENTER (list (+ (car CENTER) (car ip-block))(+ (cadr CENTER) (cadr ip-block))))
        );1
        );cond
    );progn
    );if
);progn
);if



(while (/= k 1)

(setq e  (grread 1 5 2))

(setq z e)
(setq flag (car z))
(setq pt (cadr z))
(setq pe pt)
(cond
;===========
;===========
;===========
;---------------------------Mouse go on graphic field-------------------------
((= flag 5)
(progn

(cond
((= flag-ent "LINE")(DRAW-VIRT-SHER-ONLINE color))
((= flag-ent "ARC")(DRAW-VIRT-SHER-ONARC color))
);cond

);progn
);e=5
;---------------------------Pressed keyboard--------------------------------
((= flag 2)
(progn
(if (= keypressed 0)(setq keypressed 1)(setq keypressed 0));if
);progn
);E=2

;---------------------------Click on graphic field--------------------------
((= flag 3)
(progn
(setq k 1)

);progn
);E=3
;---------------------------Mouse click on button---------------------------
((= flag 11)
(progn
(setq s (cadr z))
(cond 
((= s nz1) 
(progn
(setq p1 (getpoint "First corner:"))
(setq p2 (getcorner p1 "Second corner:"))
(command "ZOOM" "W" p1 p2)
);progn
);2110
((= s nz2) (command "ZOOM" "P"))
((= s nz3) (command "ZOOM" "E"))
((= s nz4) (command "_.PAN" pause pause))
((= s nz5) (command "ZOOM" ""))
((= s 0) (setq k 1));---------------------------Mouse right-klick on graphic field---------------
);cond
(print s)
);progn
);E=11
;===========
;===========
;===========
);cond

);while
(command "'_redrawall")
(DRAW-SHER p ang1 txt)
(setq a T)
);progn
(setq a nil)
);if/=nilsetq name
);DEFUN




;----------------------------------------
;----------------------------------------
;----------------------------------------
;----------------------------------------
;----------------------------------------
;----------------------------------------
;----------------------------------------
;----------------------------------------
;----------------------------------------
;----------------------------------------
;----------------------------------------
;----------------------------------------
;----------------------------------------
;----------------------------------------
;main function
(defun C:SHER ( / k)
(GETPARAM)
(princ "Enter sher insert point:")
(setq txt (SX 1))
(setq k 0)
(while (= k 0)
(setq start-name (entlast))
(if (not (SHER-DYNAMIC))
(progn
;(command "ORTHO" "ON")
;(setq p (getpoint1 "nea"))
;(setq ang (getangle p "Enter sher angle:"))
;(command "ORTHO" "OFF")
;(-SHER p ang txt)
(setq k 1)
(princ)
);progn
(progn
(setq NBR (DEFINE-NBR start-name))
(MAKEGROUP NBR)
);progn
);ifnot
);while
(SETPARAM)
);defun


(defun -SHER (p ang txt)
(setq d txt)
(setvar "OSMODE" 0)
(if (not (FINDLAYER "DIM")) (command "LAYER" "M" "DIM" "C" 4 "DIM" ""));if

(if (and (<= ang 3.149) (/= ang 0))
(progn
(setq p1 (polar p (+ ang 0.55) 3))
(setq p2 (polar p (- ang 0.55) 6))
(SETQ P22 (POLAR P (- ANG 0.55) 11.468))
;(SETQ P3 (POLAR P ANG 3))
(SETQ P3 (POLAR P (- ang 0.5) 3.5))
(if (or (= d "5") (= d "10")) (SETQ P3 (POLAR P (- ang 0.1) 3.0)) );if
(if (or (= d "20") (= d "40") (= d "80")) (SETQ P3 (POLAR P (- ang 0.3) 3.1)) );if
(setq p4 (polar p ang 1.92))
(command "PLINE" p1 p p2 "")
(command "chprop" (entlast) "" "LA" "DIM" "C" "BYLAYER" "")
(if (/= d "Zero!")
(progn
(command "TEXT" "R" p3 (- (* ang (/ 180 pi)) 90) d)
(command "chprop" (entlast) "" "LA" "DIM" "C" "WHITE" "")
(setq name2 (entlast))
(setq data2 (entget name2))
(setq data2 (subst (cons 40 3.0) (assoc 40 data2) data2))
(entmod data2)
(setq len (GET-NAMETEXT-LEN name2))
(if (> len 5.5) 
(progn
(setq l-ratio (/ 5.5 len))
(setq data2 (subst (cons 41 (* (cdr (assoc 41 data2)) l-ratio)) (assoc 41 data2) data2))
(entmod data2)
);progn
);if
);progn
(progn
(command "CIRCLE" p4 "d" 2)
(command "chprop" (entlast) "" "LA" "DIM" "C" "BYLAYER" "")
);progn
);if
);progn
);if


(if (or (> ang 3.149) (= ang 0))
(progn
(setq p1 (polar p (- ang 0.55) 6))
(setq p2 (polar p (+ ang 0.55) 3))
(SETQ P22 (POLAR P (+ ANG 0.55) 11.468))
;(SETQ P3 (POLAR P ANG 7))
(SETQ P3 (POLAR P (- ang 0.25) 6.0))
(if (or (= d "5") (= d "10")) (SETQ P3 (POLAR P (- ang 0.1) 6.0)) );if
(if (or (= d "20") (= d "40") (= d "80")) (SETQ P3 (POLAR P (- ang 0.2) 6.2)) );if
(setq p4 (polar p ang 1.92))
(command "PLINE" p1 p p2 "")
(command "chprop" (entlast) "" "LA" "DIM" "C" "BYLAYER" "")
(if (/= d "Zero!")
(progn
(command "TEXT" p3 (+ (* ang (/ 180 pi)) 90) d)
(command "chprop" (entlast) "" "LA" "DIM" "C" "WHITE" "")
(setq name2 (entlast))
(setq data2 (entget name2))
(setq data2 (subst (cons 40 3.0) (assoc 40 data2) data2))
(entmod data2)
(setq len (GET-NAMETEXT-LEN name2))
(if (> len 5.5) 
(progn
(setq l-ratio (/ 5.5 len))
(setq data2 (subst (cons 41 (* (cdr (assoc 41 data2)) l-ratio)) (assoc 41 data2) data2))
(entmod data2)
);progn
);if
);progn
(progn
(command "CIRCLE" p4 "d" 2)
(command "chprop" (entlast) "" "LA" "DIM" "C" "BYLAYER" "")
);progn
);if
);progn
);if

);defun-SHER






















